<template>
  <div id="app">
    <Preview @endPreview="updatePreview" v-if="in_preview"/>
    <Quiz v-if="in_quiz" :quiz="game.quiz" v-on:enterName="enterName($event)" />
    <Main v-if="in_game" :game="game" />
    <div id="loose" v-if="!game.win && !game.in_game && !in_quiz && !in_preview">
      <h1>Vous avez perdu !</h1>
      <p>Voulez-vous recommencez ?</p>
      <div class="btn" @click="restart(false)">Recommencer</div>
      <div class="btn" @click="restart(true)">Recommencer avec un autre personnage</div>
    </div>
    <div id="win" v-if="game.win && !in_quiz && !in_preview">
      <h1>Vous avez gagné !</h1>
      <p>Voulez-vous recommencez ?</p>
      <div class="btn" @click="restart(false)">Recommencer</div>
      <div class="btn" @click="restart(true)">Recommencer avec un autre personnage</div>
    </div>
  </div>
</template>

<script>

import {Game} from "./game/game";
import Preview from "./components/Preview";
import Quiz from "./components/quiz/Quiz";
import {Player} from "./game/entity/player";
import Main from "./components/Main";

export default {
  name: 'App',
  components: {Main, Quiz, Preview},
  data: function() {
    return {
      game: new Game(),
      in_preview: true,
      in_quiz: false,
      in_game: false
    }
  },
  methods: {
    updatePreview: function(value) {
      this.in_preview = !value; //Fin de la preview
      this.in_quiz = value; //Début du quiz
    },
    enterName: function(value) {
      this.in_quiz = false;
      let data = this.game.quiz.buildCharacter(value);
      this.game.player = new Player(data.playable);
      this.game.allies = data.allies;

      this.in_game = true;
      this.game.init();
    },
    restart: function (quiz) {
      this.in_quiz = quiz;
      this.in_game = !quiz;

      if(!quiz) {
        this.enterName(this.game.player.character.name);
      } else {
        this.game.quiz.reset();
      }
    }
  }
  // ,
  // created() {
  //
  //   this.game.quiz.nextQuestion(this.game.quiz.getQuestion().responses[0]);
  //   let data = this.game.quiz.buildCharacter("Test");
  //   this.game.player = new Player(data.playable);
  //   this.game.allies = data.allies;
  //   this.game.init();
  //
  // }
}
</script>

<style>
@import "./assets/main.css";

#app {
  display: flex;
  flex-direction: column;
  align-items: center;
  flex: 1;
}

#loose, #win {
  position: absolute;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  background-color: rgba(50,50,50,0.85);

  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  color: white;
}

#loose .btn:hover {
  color: black !important;
}
</style>
